﻿if ($(Test-Path C:\Scripts\PolicyDefinitions) -eq $False) {
    Write-Host -ForegroundColor "Red" "Los ficheros de origen no se encuentran en la carpeta adecuada: ", C:\Scripts\PolicyDefinitions
    Write-Host -foregroundColor "white" "Pulse una tecla para continuar ..."
    $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
    Exit
    }

$dict = @{}
$archives = @()

$archives = Get-ChildItem -Recurse C:\Windows\PolicyDefinitions

$archives | % {
    $dict.Add($_.FullName,$(get-acl $_.FullName).Owner.ToString())
}

cmd /c icacls "C:\Windows\PolicyDefinitions" /save "C:\Scripts\fileACL.txt" /T | out-null

cmd /c takeown /F "C:\Windows\PolicyDefinitions" /A /r | out-null

foreach ($archive in $archives)
{
    cmd /c icacls $archive.FullName /grant Administradores:F | out-null
}

cmd /c xcopy /E /R /I /Q /K /Y C:\Scripts\PolicyDefinitions\*.* c:\Windows\PolicyDefinitions

foreach ($file in $dict.Keys)
{
    cmd /c icacls $file /setowner $dict[$file] | out-null
}

cmd /c icacls "C:\Windows\PolicyDefinitions" /grant Administradores:F | out-null
cmd /c icacls "C:\Windows\PolicyDefinitions" /setowner "NT SERVICE\TrustedInstaller" | out-null

cmd /c icacls "C:\Windows" /restore "C:\Scripts\fileACL.txt" | out-null

cmd /c del "C:\Scripts\fileACL.txt" | out-null