﻿
$objs = @()
$ErrorActionPreference = 'SilentlyContinue'
$ADProperty = 'groupstoignore'

try
{
    $objUser = New-Object System.Security.Principal.NTAccount(whoami)

    $strSID = $objUser.Translate([System.Security.Principal.SecurityIdentifier])
    [string]$SID = $strSID.Value

    $objRootLDAP = $null
    $objRootLDAP = New-Object System.DirectoryServices.DirectoryEntry('LDAP://rootDSE')

    if ($null -eq $objRootLDAP.Path)
    {
       'No hay conexión con el Controlador de Dominio, por lo tanto no se puede obtener la información del último inicio de sesión.'       
    }
    else
    {
        'Fecha y hora del último inicio de sesión correcto.'

        $directoryEntry = $objRootLDAP.Get('defaultNamingContext')

        $objDomain = New-Object System.DirectoryServices.DirectoryEntry('LDAP://' + $directoryEntry)
	    $objSearcher = New-Object System.DirectoryServices.DirectorySearcher

	    $objSearcher.SearchRoot = $objDomain
	    $objSearcher.SearchScope = "Subtree"
        $objSearcher.Filter = '(&(objectCategory=User)(objectSid=' + $SID + '))'
	    $objSearcher.PropertiesToLoad.Clear()

	    $colResults = $objSearcher.FindAll()

        if ($null -ne $colResults -and 0 -ne $colResults.Count)
        {
            [string]$lastLogonFromAD = ''
            [string]$lastLogonDateFromADProperty = ''

            $lastLogonFromAD = [datetime]::FromFileTime($colResults[0].Properties.lastlogon[0].ToString()).ToString()

            [string]$valuecontent = ''
            $valuecontent = $colResults[0].Properties.Item($ADProperty)
            if ($null -eq $valuecontent -or "" -eq $valuecontent)
            {
                'No hay información del primer inicio de sesión'
                $user = [ADSI]$colResults[0].Path
                $user.$ADProperty=$lastLogonFromAD
                $user.SetInfo()
            }
            else
                $lastLogonDateFromADProperty = ($colResults[0].Properties.$ADProperty)[0]
            {
                $lastLogonDateFromADProperty
            
                $user = [ADSI]$colResults[0].Path
                $user.$ADProperty=$lastLogonFromAD
                $user.SetInfo()
            }
        }
    }    
}
Catch [Exception]
{
     'No hay conexión con el Controlador de Dominio, por lo tanto no se puede obtener la información del último inicio de sesión.'   
}